
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

a, b, c, a', b', c', n, n' :: (Eq t, Num t) => Polynomial t
a  = var "a"
a' = var "'a"
b  = var "b"
b' = var "'b"
c  = var "c"
c' = var "'c"
n  = var "n"
n' = var "'n"

-- | Initial state, exit and post condition, and transitions
init = ideal [ a - n,
               b - template "syni1" 1 ["n"],
               c - template "syni2" 1 ["n"]]
exit = ideal [ a ]
post = ideal [ b - n*n*n ]
transitions = [ideal [ a' - a + 1,
                       b' - template "syn_b" 1 ["a", "b", "c", "n"],
                       c' - template "syn_c" 1 ["a", "b", "c", "n"],
                       n' - n ]]

main :: IO ()
main = dosynthesis 1 init exit post transitions [] 3 ["a", "b", "c", "n"]
