
import Prelude hiding (init)

import Polynomial hiding (d)
import Ideal
import Synthesis

{-

def div_mod(a, d):
	"""calculates the division with remainder of a by d"""
	# Dijkstra. A Discipline of Programming. 1976
	q = 0
	r = a
	while r >= d:
		assert(a == q*d + r)
		r = r - d
		q = q + 1
	return (q, r)

-}

-- | Program variables
a, a', d, d', q, q', r, r' :: (Eq t, Num t) => Polynomial t
a  = var "a"
a' = var "'a"
d  = var "d"
d' = var "'d"
q  = var "q"
q' = var "'q"
r  = var "r"
r' = var "'r"

-- | Initial state, exit and post condition, and transitions
init = ideal [ q - 0, r - a ]
exit = 0
transitions = [ideal [r' - r + d, q' - q - 1, a' - a, d' - d]]

main = dosynthesis 1 init exit 0 transitions [] d ["a", "d", "q", "r"]
       where d = 2
